#!/usr/bin/env python
# -*- coding: UTF-8 -*-
#
# Copyright © 2009 Leandro Regueiro Iglesias
#
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 2 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#----------------------------------------------------------------------
#
#Este é un programa de software libre e, xa que logo, vostede pode 
#redistribuílo e/ou modificalo consonte os termos establecidos na licenza 
#pública xeral de GNU segundo a súa publicación pola Free Software Foundation. 
#Pode escoller a versión 2 da licenza ou, se prefire, calquera outra versión 
#posterior.
#
#Este programa distribúese coa esperanza de que resulte útil, se ben NON TEN 
#NINGUNHA GARANTÍA, nin sequera a garantía implícita de COMERCIABILIDADE ou 
#IDONEIDADE PARA UN DETERMINADO FIN.  Para obter información máis detallada 
#pode consultar a licenza pública xeral de GNU.
#
#Dáse por sentado que recibiu unha copia da licenza pública xeral de GNU xunto
#con este programa. Se non for así, vexa <http://www.gnu.org/licenses/>.

import os, sys, sqlite3

DB_PATH = os.getcwd()

noteDic = {
    u"verb" : u"v",
    u"noun" : u"s",
    u"adjective" : u"adx",
    u"feminine" : u"f",
    u"masculine" : u"m",
    u"preposition" : u"prep",
    u"plural" : u"pl",
    u"locución" : u"loc",
    u"coloquial" : u"col",
    u"sigla" : u"sg",
    u"abreviatura" : u"abrev",
    u"interxección" : u"interx",
    u"abbreviation" : u"abrev",
}



def tenTraducionExacta(frase, cadeaBuscar):
    ini = 0
    ato = 0
    lonx = len(cadeaBuscar)
    
    for vez in range(frase.count(cadeaBuscar)):
        ato = frase[ini:].find(cadeaBuscar)
        ini = ini + ato + lonx
        if ini - lonx == 0:# se se atopa a cadea a buscar na primeira posición da frase
            if len(frase) == lonx:# se a frase ten a mesma lonxitude que a cadea a buscar, entón as 2 cadeas son iguais
                return True
            elif frase[ini] == " ":# se na posición seguinte hai un espazo
                return True
        # se cadeaBuscar está no final da frase e antes hai espazo. Xa descartamos o caso len(frase)==len(cadeaBuscar)
        if ini == len(frase) and frase[ini - lonx - 1] == " ":# comprobar que antes hai espazo, porque devolve aparicións polo medio dunha palabra tamén. Ex: cadeaBuscar="can" frase"mexacan"
            return True
        # xa vimos tódolos outros casos, queda o de cadeaBuscar polo medio da frase cun espazo antes, e outro despois
        if frase[ini - lonx - 1] == " " and frase[ini] == " ":
            return True
    return False# no caso de que non atopara absolutamente ningunha coincidencia exacta na frase





def buscaInexacta(cadeaBuscar):
    conexion = sqlite3.connect(DB_PATH + '/bd_glosarios_galego.bd')
    cursor = conexion.cursor()
    numConceptos = 0
    numTraducions = 0
    
    #obter a lista de conceptos que conteñan a cadea a buscar nalgún dos seus orixinais en inglés
    cursor.execute("SELECT DISTINCT id_concepto FROM traducion WHERE idioma=\"en\" AND texto LIKE '%"+cadeaBuscar+"%'")
    for concepto in cursor.fetchall():
        numConceptos += 1
        idConcepto = str(concepto[0])
        
        #obter o ámbito, definición e nome do glosario do concepto actual
        cursor.execute("SELECT ambito, definicion, exemplo, nome_glosario FROM concepto WHERE id_concepto="+idConcepto)
        amb, defi, exemplo, glos = cursor.fetchall()[0]
        
        #obter a lista de orixinais en inglés do concepto
        cursor.execute("SELECT * FROM traducion WHERE id_concepto=" + idConcepto + " AND idioma=\"en\"")
        orixinais = u""
        for orixinal in cursor.fetchall():
            #[(60, u'Hyper Transfer Prot', u'en', u'', u'', u'', u'', 27), (61, u'HTTP', u'en', u'', u'', u'', u'', 27)]
            if (orixinais == u""):
                orixinais = u"\"" + orixinal[1] + u"\""
            else:
                orixinais = orixinais + u", \"" + orixinal[1] + u"\""
        
        #mostrar a cabeceira do concepto
        cabeceiraMostrar = u"\n\n" + orixinais + u"  (" + glos + u"):"
        if (amb != u""):
            cabeceiraMostrar = cabeceiraMostrar + u"\n\tÁmbitos:  " + amb
        if (defi != u""):
            cabeceiraMostrar = cabeceiraMostrar + u"\n\tDefinición:  " + defi
        if (exemplo != u""):
            cabeceiraMostrar = cabeceiraMostrar + u"\n\tExemplo:  \"" + exemplo + u"\""
        print (cabeceiraMostrar + u"\n")
        
        #obter a lista de traducións ao galego do concepto
        cursor.execute("SELECT * FROM traducion WHERE id_concepto=" + idConcepto + " AND idioma=\"gl\"")
        for traducion in cursor.fetchall():
            numTraducions += 1
            #(idTrad, texto, idioma, recomendada?, partOfSpeech, grammaticalGender, grammaticalNumber, id_concepto)
            texto = traducion[1]
            recomendada = traducion[3]
            partOfSpeech = traducion[4]
            grammaticalGender = traducion[5]
            grammaticalNumber = traducion[6]
            
            #xa temos os datos da traducion
            textoTraducion = u"\t\"" + texto + u"\""
            if (partOfSpeech != u""):
                textoTraducion = textoTraducion + u" [" + noteDic[partOfSpeech]
                if (grammaticalGender != u""):
                    textoTraducion = textoTraducion + noteDic[grammaticalGender]
                textoTraducion = textoTraducion + u"]"
            if (recomendada == u"true"):
                textoTraducion = textoTraducion + u" (recomendada)"
            print (textoTraducion)
    conexion.commit()
    cursor.close()
    conexion.close()
    print ("\n\n   Conceptos: " + str(numConceptos) + "    Traducions: " + str(numTraducions) + "\n")





def buscaExacta(cadeaBuscar):
    conexion = sqlite3.connect(DB_PATH + '/bd_glosarios_galego.bd')
    cursor = conexion.cursor()
    numConceptos = 0
    numTraducions = 0
    tenTradExacta = False
    listaConceptos = []
    conceptoActual = []
    
    #obter a lista de conceptos que conteñan a cadea a buscar nalgún dos seus orixinais en inglés
    cursor.execute("SELECT DISTINCT id_concepto FROM traducion WHERE idioma=\"en\" AND texto LIKE '%"+cadeaBuscar+"%'")
    for concepto in cursor.fetchall():
        tenTradExacta = False
        idConcepto = str(concepto[0])
        
        #obter a lista de orixinais en inglés do concepto
        cursor.execute("SELECT * FROM traducion WHERE id_concepto=" + idConcepto + " AND idioma=\"en\"")
        orixinais = u""
        for orixinal in cursor.fetchall():
            #[(60, u'Hyper Transfer Prot', u'en', u'', u'', u'', u'', 27), (61, u'HTTP', u'en', u'', u'', u'', u'', 27)]
            tradOrixinal = orixinal[1]
            
            if (not tenTradExacta and cadeaBuscar in tradOrixinal.lower()):
                #execútase isto se no orixinal está cadeaBuscar e non apareceu ningún orixinal con coincidencia exacta
                tenTradExacta = tenTraducionExacta(tradOrixinal.lower(), cadeaBuscar)
            
            if (orixinais == u""):
                orixinais = u"\"" + tradOrixinal + u"\""
            else:
                orixinais = orixinais + u", \"" + tradOrixinal + u"\""
        
        
        
        
        #se resulta que non ten tradución exacta non seguimos!!!!!!!!!
        if tenTradExacta:
            conceptoActual = []
            
            #obter o ámbito, definición e nome do glosario do concepto actual
            cursor.execute("SELECT ambito,definicion,exemplo,nome_glosario FROM concepto WHERE id_concepto="+idConcepto)
            amb, defi, exemplo, glos = cursor.fetchall()[0]
            
            #crear a cabeceira do concepto: orixinais, glosario, definición, ámbito, exemplos...
            cabeceiraMostrar = u"\n\n" + orixinais + u"  (" + glos + u"):"
            if (amb != u""):
                cabeceiraMostrar = cabeceiraMostrar + u"\n\tÁmbitos:  " + amb
            if (defi != u""):
                cabeceiraMostrar = cabeceiraMostrar + u"\n\tDefinición:  " + defi
            if (exemplo != u""):
                cabeceiraMostrar = cabeceiraMostrar + u"\n\tExemplo:  \"" + exemplo + u"\""
            cabeceiraMostrar = cabeceiraMostrar + u"\n"
            conceptoActual = [cabeceiraMostrar, []]#[textoConcepto, lista trads]#########
            listaConceptos.append(conceptoActual)#######################################################################
            
            #obter a lista de traducións ao galego do concepto
            cursor.execute("SELECT * FROM traducion WHERE id_concepto=" + idConcepto + " AND idioma=\"gl\"")
            for traducion in cursor.fetchall():
                #(idTrad, texto, idioma, recomendada?, partOfSpeech, grammaticalGender, grammaticalNumber, id_concepto)
                texto = traducion[1]
                recomendada = traducion[3]
                partOfSpeech = traducion[4]
                grammaticalGender = traducion[5]
                grammaticalNumber = traducion[6]
                #xa temos os datos da traducion
                textoTraducion = u"\t\"" + texto + u"\""
                if (partOfSpeech != u""):
                    textoTraducion = textoTraducion + u" [" + noteDic[partOfSpeech]
                    if (grammaticalGender != u""):
                        textoTraducion = textoTraducion + noteDic[grammaticalGender]
                    textoTraducion = textoTraducion + u"]"
                if (recomendada == u"true"):
                    textoTraducion = textoTraducion + u" (recomendada)"
                conceptoActual[1].append(textoTraducion)###################################
    #mostramos os datos en diferido (todos son resultados exactos)
    for conc in listaConceptos:
        numConceptos += 1
        print conc[0]
        for tradu in conc[1]:
            numTraducions += 1
            print tradu
    print ("\n\n   Conceptos: " + str(numConceptos) + "    Traducions: " + str(numTraducions) + "\n")
    conexion.commit()
    cursor.close()
    conexion.close()




if __name__ == "__main__":
    if (len(sys.argv) > 2 and (sys.argv[1] == "--fuzzy" or sys.argv[1] == "--exact")):
        parametros = ""
        for pos in range(2, len(sys.argv)):
            parametros = parametros + " " + sys.argv[pos]
        #chamamos á función de busca solicitada
        if sys.argv[1] == "--fuzzy":
            buscaInexacta(parametros.strip().lower())
        else:
            buscaExacta(parametros.strip().lower())
    else:
        print ("\nModo de uso: ./script.py OPCIÓN termo_a_buscar_en_minusculas\n")
        print ("\tOPCIÓN ten que ser --fuzzy ou --exact")
        print ("\ttermo_a_buscar_en_minusculas pode ser unha frase con espazos polo medio\n\n")
        exit(0)


